package com.picfun.bt_wavegene;


import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.Gravity;
import android.view.View;
import android.widget.EditText;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

@SuppressLint({ "HandlerLeak", "DrawAllocation" })
public class WaveGene extends Activity {
	/**** クラス定数宣言定義 ****/
	public static final int CONNECTDEVICE = 1;
	public static final int ENABLEBLUETOOTH = 2;
	// BTインスタンス定数
	private BluetoothAdapter BTadapter;
	private BluetoothClientC BTclient;
	// バッファ、一般変数定義
	private byte[] RcvPacket = new byte[4100];		// 受信バッファ
	private byte[] SndPacket = new byte[64];			// 送信バッファ
	private int[] DataBuffer = new int[2000];			// データバッファ
	private static int TrigLevel, Index, temp, Herz;
	private static byte Hsync, FirstFlag, fFlag;
	private static long lHerz;
	private int i, j;
	// クラス変数、定数の宣言
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private static Button[] sample = new Button[7];
	private static Button select, setfreq;	
	private static TextView text, text0, text10, text11;
	private static EditText Freq;
	private static MyView graph;
	
	/***************** 最初に実行されるメソッド *************/
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        /* フルスクリーンの指定 */
        getWindow().clearFlags(WindowManager.LayoutParams.FLAG_FORCE_NOT_FULLSCREEN);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN); 
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);       
        requestWindowFeature(Window.FEATURE_NO_TITLE);    
        /*** レイアウト定義　*******/     
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.HORIZONTAL);
        setContentView(layout); 
        // サブレイアウト
        LinearLayout layout2 = new LinearLayout(this);
        layout2.setOrientation(LinearLayout.VERTICAL);
        layout.setBackgroundColor(Color.BLACK);             
        layout2.setGravity(Gravity.LEFT); 
        // 見出しテキスト表示             
        text = new TextView(this);
        text.setLayoutParams(new LinearLayout.LayoutParams(389,WC));
        text.setTextSize(23f);
        text.setTextColor(Color.MAGENTA);            
        text.setText("Wave Generator");
        layout2.addView(text);
        // 接続ボタン作成
        select = new Button(this);
        select.setBackgroundColor(Color.CYAN);
        select.setTextColor(Color.BLACK);
        select.setTextSize(18f);
        select.setText("端末接続");
        LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(200, 80);
        params.setMargins(10,10, 0,0);       
        select.setLayoutParams(params);
        layout2.addView(select);  
        // 接続結果表示テキスト
        LinearLayout.LayoutParams params3 = new LinearLayout.LayoutParams(300, 50);       
        text0 = new TextView(this);
        text0.setTextColor(Color.WHITE);
        text0.setTextSize(18f);
        text0.setLayoutParams(params3);
        text0.setText("接続待ち");
        layout2.addView(text0);  
        // 出力設定見出し
        params3.setMargins(10,20, 0,0);
		text11 = new TextView(this);
		text11.setTextColor(Color.WHITE);         
		text11.setTextSize(18f);
		text11.setLayoutParams(params3);
		text11.setText("出力周波数設定");
		layout2.addView(text11);     
		// D/A出力周波数設定
        LinearLayout.LayoutParams params1 = new LinearLayout.LayoutParams(250, 80);
        params1.setMargins(10,10, 0,0);       
	    Freq = new EditText(this);
	    Freq.setTextColor(Color.BLACK);
	    Freq.setTextSize(20f);
	    Freq.setBackgroundColor(Color.WHITE);
	    Freq.setLayoutParams(params1);
	    Freq.setText("1000");
	    layout2.addView(Freq);
	    // 周波数設定ボタン
	    setfreq = new Button(this);
	    setfreq.setBackgroundColor(Color.CYAN);
	    setfreq.setTextColor(Color.BLACK);
	    setfreq.setTextSize(18f);
	    setfreq.setText("設定");
	    setfreq.setLayoutParams(params);
	    layout2.addView(setfreq);
	    // サンプリング周期設定タイトル
	    text10 = new TextView(this);
	    text10.setTextColor(Color.WHITE);         
	    text10.setTextSize(18f);
	    text10.setLayoutParams(params3);
	    text10.setText("水平同期");
	    layout2.addView(text10); 
	    // サンプリング周期設定ボタン生成        
        LinearLayout.LayoutParams params2 = new LinearLayout.LayoutParams(180, 70);
        params2.setMargins(10,10, 0,0);
        for(i=0; i<7; i++){
	        sample[i] = new Button(this);
	        sample[i].setBackgroundColor(Color.GREEN);
	        sample[i].setTextColor(Color.BLACK);            
	        sample[i].setTextSize(16f);
            sample[i].setLayoutParams(params2);
            layout2.addView(sample[i]);         
          }
        sample[0].setText("2.5μs/Div");
        sample[1].setText("5μs/Div");
        sample[2].setText("25μs/Div");
        sample[3].setText("100μs/Div");
        sample[4].setText("500us/Div");
        sample[5].setText("1ms/Div");
        sample[6].setText("10ms/Div");
    layout.addView(layout2);
    // グラフ描画
    graph = new MyView(this);
    layout.addView(graph); 
    // ボタンイベントリスナ生成
    select.setOnClickListener((OnClickListener) new SelectExe());  
    setfreq.setOnClickListener((OnClickListener) new SetFreq());
    for(i=0; i<7; i++)
        sample[i].setOnClickListener((OnClickListener) new syncScope());       
    // Bluetoothが有効な端末か確認
    BTadapter = BluetoothAdapter.getDefaultAdapter();
    if (BTadapter == null) {
    	text0.setTextColor(Color.YELLOW);
    	text0.setText("Bluetooth未サポート");
    	}
    // 初期表示用正弦波データ格納
    for(i=0; i<2000; i++)
    	DataBuffer[i] = (int)(500*(Math.sin(Math.toRadians((double)i))));
    	Hsync = 4;
    	FirstFlag = 1;
    	fFlag = 0;
    }
    /******* アクティビティ開始時（ストップからの復帰時）****/
    @Override
    public void onStart() {
    	super.onStart();
    	if (BTadapter.isEnabled() == false) {		// Bluetoorhが有効でない場合
    		// Bluetoothを有効にするダイアログ画面に遷移し有効化要求
    		Intent BTenable = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
    		// 有効化されて戻ったらENABLEパラメータ発行
    		startActivityForResult(BTenable, ENABLEBLUETOOTH);
    	}
    	else {
    		if (BTclient == null) {
    			// BluetoothClientをハンドラで生成
    			BTclient = new BluetoothClientC(this, handler);
    		}
    	}
    }
    /***** アクティビティ再開時（ポーズからの復帰時）********/
    @Override
    public synchronized void onResume() {
    	super.onResume();
    	// 特に処理なし
    }
    /********* アクティビティ破棄時 *************************/
    @Override
    public void onDestroy() {
    	super.onDestroy();
    	if (BTclient != null) {
    		BTclient.stop();
    	}
    }
    /*********** 接続ボタンイベントクラス *******************/
    class SelectExe implements OnClickListener{
    	public void onClick(View v){
    		// デバイス検索と選択ダイアログへ移行    
    		Intent Intent = new Intent(WaveGene.this, DeviceListActivity.class);
    		// 端末が選択されて戻ったら接続要求するようにする
    		startActivityForResult(Intent, CONNECTDEVICE);
    		}
      }
    /********** 遷移ダイアログからの戻り処理 ****************/
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
    	switch (requestCode) {
    	// 端末選択ダイアログからの戻り処理
    	case CONNECTDEVICE: // 端末が選択された場合
    		if (resultCode == Activity.RESULT_OK) {
    			String address = data.getExtras().getString(DeviceListActivity.DEVICEADDRESS);
    			// 生成した端末に接続要求
    			BluetoothDevice device = BTadapter.getRemoteDevice(address);
    			BTclient.connect(device);	// 端末へ接続
    		}
    		break;
    		// 有効化ダイアログからの戻り処理
    	case ENABLEBLUETOOTH: // Bluetooth有効化
    		if (resultCode == Activity.RESULT_OK) {
    			// 正常に有効化できたらクライアントをハンドラで生成
    			BTclient = new BluetoothClientC(this, handler);
    		}
    		else {
    			Toast.makeText(this, "Bluetoothのサポートなし", Toast.LENGTH_SHORT).show();
    			finish();
    		}
    	}
    }
    /**********  周期設定ボタンイベントクラス ***********************/
    class syncScope implements OnClickListener{
    	public void onClick(View v){
    		for(i=0; i<7; i++){				//　スイッチ種別判定
    			if(v == sample[i]){			// タップされたボタンの場合
    				Hsync = (byte)i;		// ボタン番号をHsyncに記憶
    			}
    		}
    		// バッファに周期値設定
    		SndPacket[0] = 0x53;			// S
    		SndPacket[1] = 0x54;			// T
    		SndPacket[2] = Hsync;			// サンプリング周期	
    		SndPacket[3] = 0x45;			// E
			for(i=4; i<64; i++)				// パディング
				SndPacket[i] = 0;
			if(FirstFlag == 1){				// 計測未開始の場合
				BTclient.write(SndPacket); 	// 送信実行 
				FirstFlag = 0;		
			}
     	}    		
    }
    /**********  固定出力ボタンイベントクラス ****************/
    class SetFreq implements OnClickListener{
    	public void onClick(View v){
    		// 設定周波数の取得
    		lHerz = Long.parseLong(Freq.getText().toString());
    		if(lHerz < 2000){
    			fFlag = 0x31;
    			Herz = (int)(lHerz );
    		}
    		else{
    			fFlag = 0x32;
    			Herz = (int)(lHerz / 100);
    		} 
			text0.setText("固定出力制御");
     	}    		
    }   
    
    /******** BT端末接続処理の戻り値ごとの処理実行 **********/
    private final Handler handler = new Handler() {
    	// ハンドルメッセージごとの処理
    	@Override
    	public void handleMessage(Message msg) {
    		switch (msg.what) {
    			case BluetoothClientC.MESSAGE_STATECHANGE:
    				switch (msg.arg1) {
    					case BluetoothClientC.STATE_CONNECTED:
    						text0.setTextColor(Color.GREEN);
    						text0.setText("接続完了");
    						FirstFlag = 1;
    						break;
    					case BluetoothClientC.STATE_CONNECTING:
    						text0.setTextColor(Color.WHITE);
    						text0.setText("接続中");
    						break;
    					case BluetoothClientC.STATE_NONE:
    						text0.setTextColor(Color.RED);
    						text0.setText("接続失敗");
    						break;
    				}
    				break;
    				// BT受信処理
    			case BluetoothClientC.MESSAGE_READ:
    				RcvPacket = (byte[])msg.obj;
    				Index = 0;
    				Process();
    				break;
    		}
    	}
    }; 
    /********** 受信データ処理メソッド **********************/
    public void Process(){
    	if(RcvPacket[0] == 0x4D){							// M
    		switch(RcvPacket[1]) {
    			case 0x4E:									// N
    				Index = 0;
    				for(j=2; j<4002; j+=2){
    					temp = RcvPacket[j+1]*128+RcvPacket[j];
    					DataBuffer[Index++] = (512-temp);	// 正負反転
    				}
    				handler.post(new Runnable(){
    					public void run(){
    						graph.invalidate();				// データグラフの再表示
    					}	});
    				// データ計測時間確保待ち
    				try{
    					Thread.sleep(500);					// 0.5秒お休み
    				}catch(InterruptedException e){ }
    				// D/A出力設定変更がある場合
    				if(fFlag != 0){
    					SndPacket[0] = 0x53;				// S
    					SndPacket[1] = 0x55;				// U
    					SndPacket[2] = fFlag;	
    					// 周波数フラグ　0= 変更なし 1=2kHz以下 2=2kHz以上
    					SndPacket[3] = (byte)(Herz/128);	// 周波数　HzまたはkHz
    					SndPacket[4] = (byte)(Herz%128);
    					SndPacket[5] = 0x45;				// E
    					BTclient.write(SndPacket); 			// 送信実行 
    					fFlag = 0;							// Reset    
    				}
    				// データ計測時間確保待ち
    				try{
    					Thread.sleep(500);					// 0.5秒お休み
    				}catch(InterruptedException e){ }
    				// 次のデータ送信要求
    				// バッファに周期値設定
    				SndPacket[0] = 0x53;					// S
    				SndPacket[1] = 0x54;					// T
    				SndPacket[2] = Hsync;					// サンプリング周期
    				SndPacket[3] = 0x45;					// E
    				BTclient.write(SndPacket); 				// 送信実行 
    				break;
    			default: 
    				break;
    		}
    	}
    }
    /********** グラフを描画するクラス   ********************/
    class MyView extends View{
    	// Viewの初期化	
    	public MyView(Context context){
    		super(context);
    	}
    	// グラフ描画実行メソッド
    	public void onDraw(Canvas canvas){
    		super.onDraw(canvas);
    		Paint set_paint = new Paint(); 					//背景色の設定
    		canvas.drawColor(Color.BLACK); 
    		set_paint.setColor(Color.BLUE);					// 座標の表示 青色で表示
    		set_paint.setStrokeWidth(1);
    		for(i=0; i<=15; i++)							// 縦軸の表示　15本
    			canvas.drawLine(30+i*100, 20, 30+i*100, 1050, set_paint);
    		for(i=0; i<=10; i++)							// 横軸の表示　10本　中央を0とする
    			canvas.drawLine(30, 35+i*100, 1530, 35+i*100, set_paint);
    		// X軸とY軸の0ライン白色で描画
    		set_paint.setColor(Color.WHITE);
    		canvas.drawLine(30, 535, 1530, 535, set_paint);
    		set_paint.setStrokeWidth(2);   
    		canvas.drawLine(30, 20, 1530, 20, set_paint);
    		canvas.drawLine(30, 20, 30, 1050, set_paint);
    		canvas.drawLine(30, 1050, 1530, 1050 ,set_paint);
    		canvas.drawLine(1530, 20, 1530, 1050, set_paint);
    		// 軸目盛の表示
    		set_paint.setAntiAlias(true);
    		set_paint.setTextSize(25f);
    		set_paint.setColor(Color.WHITE);
    		for(i=0; i<15; i++)								// X座標目盛
    			canvas.drawText(Integer.toString(i), 25+i*100, 1070, set_paint);   
    		for(i=-5; i<=5; i++)							// Y座標目盛
    			canvas.drawText(Integer.toString(i), 5, 545-i*100, set_paint);
    		// 水平軸時間表示
    		set_paint.setTextSize(30f);
    		set_paint.setColor(Color.GREEN);
    		switch(Hsync){
    			case 0:
    				canvas.drawText("2.5usec/Div", 400, 1100, set_paint);
    				break;
    			case 1:
    				canvas.drawText("5usec/Div", 400, 1100, set_paint);
    				break;
    			case 2:
    				canvas.drawText("25usec/Div", 400, 1100, set_paint);
    				break;
    			case 3:
    				canvas.drawText("100usec/Div", 400, 1100, set_paint);
    				break;
    			case 4:
    				canvas.drawText("500usec/Div", 400, 1100, set_paint);
    				break;
    			case 5:
    				canvas.drawText("1msec/Div", 400, 1100, set_paint);
    				break;
    			case 6:
    				canvas.drawText("10msec/Div", 400, 1100, set_paint);
    				break;
    			default:break;
    		}
    		// トリガポイント検出　0クロス
    		Index = 0;
    		TrigLevel = 3;
    		for(i=2; i<490; i++){
    			if((DataBuffer[i-1] < TrigLevel) && (DataBuffer[i] > TrigLevel)
    					&& (DataBuffer[i+1]> DataBuffer[i])){
    				Index = i-1;
    				break;
    			}
    		}
    		if(Index >= 490)
    			Index = 0;
    		// 実際のグラフの表示
    		set_paint.setColor(Color.GREEN);
    		switch(Hsync){
    			case 0:
    				for(i=0; i<150; i++)
    					canvas.drawLine(10*i+30, 535-DataBuffer[Index+i], 10*(i+1)+30,
    							535-DataBuffer[Index+i+1], set_paint);
    				break;
    			case 1:
    				for(i=0; i<300; i++)
    					canvas.drawLine(5*i+30, 535-DataBuffer[Index+i], 5*(i+1)+30,
    							535-DataBuffer[Index+i+1], set_paint);
    				break;
    			case 2:
    			case 3:
    			case 4:
    			case 5:
    			case 6:
    				for(i=0; i<1500; i++)
    					canvas.drawLine(i+30, 535-DataBuffer[Index+i], (i+1)+30,
    							535-DataBuffer[Index+i+1], set_paint);
    				break;
    			default:
    				break;
    		}
    	}
    }
}


