/*******************************************************************
 * $B%o%$%"%l%9%*%7%m%9%3!<%W(B
 *   PIC24FJ64GC006 $B$N(B10Msps$B$N%Q%$%W%i%$%s7?(BADC$B$N;HMQNc(B
 * $B!!(BTimer2$B$G(BA/D$BJQ49$7!"(BDMA$B$G%P%C%U%!$K3JG<(B
 *   $B2DG=$JJQ49B.EY$O!!(B4-5Msps$B$,8B3&!!!w(BTad=8MHz
 * $B!!%3%^%s%I$G2<5-<B9T(B
 * $B!!!!(BT$B!!!'JQ493+;O!!(B2000$B2s$N%5%s%W%j%s%0$rAw?.$9$k(B
 *******************************************************************/
#include <xc.h>
#include <math.h>
/* $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B */
// CONFIG4
#pragma config DSWDTPS = DSWDTPS1F      // Deep Sleep Watchdog Timer Postscale Select bits (1:68719476736 (25.7 Days))
#pragma config DSWDTOSC = LPRC          // DSWDT Reference Clock Select (DSWDT uses LPRC as reference clock)
#pragma config DSBOREN = OFF            // Deep Sleep BOR Enable bit (DSBOR Disabled)
#pragma config DSWDTEN = OFF            // Deep Sleep Watchdog Timer Enable (DSWDT Disabled)
#pragma config DSSWEN = OFF             // DSEN Bit Enable (Deep Sleep operation is always disabled)
#pragma config RTCBAT = OFF             // RTC Battery Operation Enable (RTC operation is discontinued in VBAT)
#pragma config PLLDIV = DIV2            // PLL Input Prescaler Select bits (Oscillator divided by 2 (8 MHz input))
#pragma config I2C2SEL = PRI            // Alternate I2C2 Location Select bit (I2C2 is multiplexed to SDA2/RA3 and SCL2/RA2 )
#pragma config IOL1WAY = OFF            // PPS IOLOCK Set Only Once Enable bit (The IOLOCK bit can be set and cleared using the unlock sequence)

// CONFIG3
#pragma config WPFP = WPFP127           // Write Protection Flash Page Segment Boundary (Page 127 (0x1FC00))
#pragma config SOSCSEL = OFF            // SOSC Selection bits (Digital (SCLKI) mode)
#pragma config WDTWIN = PS25_0          // Window Mode Watchdog Timer Window Width Select (Watch Dog Timer Window Width is 25 percent)
#pragma config BOREN = OFF              // Brown-out Reset Enable (Brown-out Reset Disabled)
#pragma config WPDIS = WPDIS            // Segment Write Protection Disable (Disabled)
#pragma config WPCFG = WPCFGDIS         // Write Protect Configuration Page Select (Disabled)
#pragma config WPEND = WPENDMEM         // Segment Write Protection End Page Select (Write Protect from WPFP to the last page of memory)

// CONFIG2
#pragma config POSCMD = EC              // Primary Oscillator Select (External-Clock Mode Enabled)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
//#pragma config OSCIOFCN = OFF           // OSCO Pin Configuration (OSCO/CLKO/RC15 functions as CLKO (FOSC/2))
#pragma config FCKSM = CSDCMD           // Clock Switching and Fail-Safe Clock Monitor Configuration bits (Clock switching and Fail-Safe Clock Monitor are disabled)
#pragma config FNOSC = PRIPLL           // Initial Oscillator Select (Primary Oscillator with PLL module (XTPLL,HSPLL, ECPLL))
#pragma config ALTADREF = AVREF_RA      // External 12-Bit A/D Reference Location Select bit (AVREF+/AVREF- are mapped to RA9/RA10)
#pragma config ALTCVREF = CVREF_RA      // External Comparator Reference Location Select bit (CVREF+/CVREF- are mapped to RA9/RA10)
#pragma config WDTCMX = WDTCLK          // WDT Clock Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config IESO = OFF               // Internal External Switchover (Disabled)

// CONFIG1
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler Select (1:32,768)
#pragma config FWPSA = PR128            // WDT Prescaler Ratio Select (1:128)
#pragma config WINDIS = OFF             // Windowed WDT Disable (Standard Watchdog Timer)
#pragma config FWDTEN = WDT_DIS         // Watchdog Timer Enable (WDT disabled in hardware; SWDTEN bit disabled)
#pragma config ICS = PGx2               // Emulator Pin Placement Select bits (Emulator functions are shared with PGEC2/PGED2)
#pragma config LPCFG = ON               // Low power regulator control (Low voltage regulator controlled in sw by RETEN bit)
#pragma config GWRP = OFF               // General Segment Write Protect (Disabled)
#pragma config GCP = OFF                // General Segment Code Protect (Code protection is disabled)
#pragma config JTAGEN = OFF             // JTAG Port Enable (Disabled)

/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
unsigned char Flag;
int Index, i, temp;
unsigned int MaxRes;                    // $B%"%J%m%0=PNO:G9bJ,2rG=(B//
unsigned int Pattern[1000];
unsigned long data;
#define  Max_Size 2016                  // $B%5%s%W%j%s%0?t(B
__attribute__((far)) unsigned char RcvBuf[64];
__attribute__((far)) unsigned int Buffer[Max_Size+50];      // Max 2020+50word

/* Bluetooth$B@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";           // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "SF,1\r";        // $B9)>l=P2Y%j%;%C%H(B
unsigned char msg3[] = "SN,WaveGene\r"; // $BL>>N@_Dj(B
unsigned char msg4[] = "R,1\r";         // $B:F5/F0(B
/* $B4X?t%W%m%H%?%$%T%s%0(B */
void Send(unsigned char Data);
void Init(void);
void SendData(unsigned int * buf);
void SendCmd(unsigned char *cmd);
void Delayms( unsigned int t);
void Cmnd(unsigned char data);
void SetupOSC(int _period);
void Hsync(unsigned char num);

/*********** $B%a%$%s4X?t(B **************************/
int main(void){
    int i;

    /* $B%/%m%C%/$N@_Dj!!(B8MHz$B"*(B96MHz$B!`(B3=32MHz */
    CLKDIVbits.RCDIV = 0;               // 1/1 8MHz
    CLKDIVbits.CPDIV = 0;               // 32/1= 32MHz
    /* I/O$B$N=i4|@_Dj(B */
    TRISB = 0x403E;
    TRISE = 0;
    TRISF = 0x0020;                     // RF5 input
    TRISG = 0x00C0;                     // RG6,7 Input
    ANSF = 0;
    ANSB = 0;
    ANSBbits.ANSB1 = 1;
    ANSBbits.ANSB2 = 1;
    ANSBbits.ANSB3 = 1;
    ANSBbits.ANSB4 = 1;                 // AN4 analog    
    ANSBbits.ANSB5 = 1;                 // OA1OUT anaalog
    ANSG = 0;
    ANSGbits.ANSG6 = 1;                 // OA1PB analog
    ANSGbits.ANSG7 = 1;                 // OA1NE analog
    /** Bluetooth$B%b%8%e!<%k%j%;%C%H(B */
    LATBbits.LATB15 = 0;                // $B%b%8%e!<%k%j%;%C%H(B
    Delayms(100);                       // $B%Q%k%9I}3NJ](B
    LATBbits.LATB15 = 1;                // $B%j%;%C%H2r=|(B
    Delayms(1000);                      // $B<B9TBT$A(B    
    /* $B%?%$%^(B2$B@_Dj!J(BA/D$BJQ49%H%j%,MQ!K(B */
    T2CON = 0;                          // Prescaler 1/1
    TMR2 = 0;
    PR2 = 3;                            // 250nsec period (4MHz)
    /* $B%?%$%^(B3$B@_Dj!J(BDA$BJQ49%H%j%,MQ(B) */
    T3CON = 0;
    TMR3 = 0;
    PR3 = 7;                            // 500nsec(2MHz)
    /* UART1$B%T%s3dIU(B */
    RPINR18bits.U1RXR = 17;             // UART1 RX to RP10(RF4)
    RPOR5bits.RP10R = 3;                // UART1 TX to RP17(RF5)
    /* UART1$B=i4|@_Dj!!(B115kbps  */
    U1MODE = 0x8808;                    // UART1$B=i4|@_Dj(B BRGH=1
    U1STA =  0x0400;                    // UART1$B=i4|@_Dj(B
    U1BRG = 34;                         // 115kbps@16MHz
    IPC2bits.U1RXIP = 4;                // UART1$B3d$j9~$_%l%Y%k(B
    IFS0bits.U1RXIF = 0;                // $B3d$j9~$_%U%i%0%/%j%"(B
    /** Bluetooth$B%b%8%e!<%k=i4|2=(B */
    CNPU1bits.CN14PUE = 1;              // RB14 Pullup
    if(PORTBbits.RB14 == 0){            // RB14$B$,(BLow$B$N>l9g(B
        SendCmd(msg1);                  // $$$
        SendCmd(msg2);                  // $B9)>l%j%;%C%H(B
        SendCmd(msg3);                  // $BL>>N@_Dj(B
        SendCmd(msg4);                  // $B%j%V!<%H(B
        /** USART $B:F@_Dj(B*/
        U1MODE = 0x8808;                // UART1$B=i4|@_Dj(B BRGH=1
        U1STA =  0x0400;                // UART1$B=i4|@_Dj(B
        U1BRG = 34;                     // 115kbps@60MHz
    }
    MaxRes = 1000;
    /*** $B@589GH%G!<%?$N@8@.(B 2kHz **/
    for(i=0; i<MaxRes; i++)
        Pattern[i] = (unsigned int)(512 - 500 * sinf(6.283032*i/MaxRes));
    /** DMA$B!"(BADC$B=i4|@_Dj(B **/
    Init();
    /** ADC Start & Ready DMA **/
    ADSTATLbits.SL0IF = 0;              // ADC Flag Clear
    DMACH0bits.CHEN = 1;                // DMA Channel Enable & Start
    IFS0bits.DMA0IF = 0;                // DMA Interrupt Flag Reset
    /** D/A DMA #1$B3+;O(B **/
    ADSTATLbits.SL1IF = 0;              // ADC Flag Clear
    DMACH1bits.CHEN = 1;                // DMA Channel Enable & Start
    IFS0bits.DMA1IF = 0;                // DMA Interrupt Flag Reset
    T3CONbits.TON = 1;
    /* $BJQ?t=i4|2=(B */ 
    Index = 0;                          // $B=i4|>uBV$K%;%C%H(B
    Flag = 0;
    /* UART1 $B3d$j9~$_5v2D(B */
    IEC0bits.U1RXIE = 1;                // UART1$B<u?.3d$j9~$_5v2D(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        /* $B<u?.%3%^%s%I=hM}(B */
        if((Flag == 1) && (RcvBuf[0] == 'S')) {
                Flag = 0;                                   // $B<u?.40N;%U%i%0%/%j%"(B
                /* $B%G!<%?=hM}(B  */
            switch(RcvBuf[1]){                              // $B<u?.%G!<%?$GJ,4t(B
                /** $B%G!<%?7WB,3+;O%H%j%,(B ***/
                case 'T':
                    /* $B%5%s%W%j%s%0<~4|@_Dj$H%G!<%?Aw?.(B */
                    T2CONbits.TON = 0;                      // $B%?%$%^(B2$BDd;_(B
                    TMR2 = 0;                               // $B%?%$%^(B2$B%j%;%C%H(B
                    Hsync(RcvBuf[2]);                       // $B%5%s%W%k<~4|@_Dj(B
                    Index = 0;                              // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
                    /*** Max_Size$B2s%5%s%W%j%s%0=*N;BT$A(B ***/
                    T2CONbits.TON = 1;                      // $B%?%$%^(B2$B3+;O!"%5%s%W%j%s%03+;O(B
                    while(IFS0bits.DMA0IF == 0);            // Wait Max_Size sampling
                    T2CONbits.TON = 0;                      // Stop Timer2 & ADC
                    IFS0bits.DMA0IF = 0;                    // Clear DMA Interrupt Flag
                    /* $B<}=840N;!"%G!<%?Aw?.<B9T(B */
                    Buffer[Max_Size+1] = 0x4545;            // $B=*N;%^!<%/(B EE
                    SendData(Buffer+16);                    // $B@hF,(B16$B8D%9%-%C%W(B
                    break;
                case 'U':
                     /** D/A$B=PNO@_Dj(B **/
                    if(RcvBuf[2] != 0){
                        LATEbits.LATE2 ^= 1;
                        T3CONbits.TON = 0;                  // $B%?%$%^(B3$BDd;_(B
                        if(RcvBuf[2] == '1'){               // 2kHz$B0J2<$N>l9g(B
                            temp = RcvBuf[3]*128+RcvBuf[4];
                            MaxRes = 1000;
                            PR3 = 16000/temp - 1;
                        }
                        else if(RcvBuf[2] == '2'){          // 2kHz$B0J>e$N>l9g(B
                            temp = RcvBuf[3]*128+RcvBuf[4];
                            MaxRes = 20000/temp;
                            PR3 = 7;
                        }
                        /*** $B@589GH%G!<%?$N@8@.(B  **/
                        for(i=0; i<MaxRes; i++){
                            Pattern[i] = (unsigned int)(512 - 500 * sinf(6.283032 * i / MaxRes));
                        }
                        DMACNT1 = MaxRes;                   // DMA Counter MaxRes
                        T3CONbits.TON = 1;                  // Timer3 Restart

                    }
                    break;
                default:                                    // $B$I$l$G$b$J$$>l9g(B
                    break;
            }
        }
    }
}
/**************************************************
 * $B%O!<%I%&%'%"=i4|2=(B
 * $B!!(BOPAMP, DMA$B!"(BADC$B!"(BDAC
 **************************************************/
void Init(void){
    /*** OP AMP#1 Setting ****/
    AMP1CONbits.AMPOE = 1;                  // Output Enable
    AMP1CONbits.NINSEL = 5;                 // OA1NE select(RG7)
    AMP1CONbits.PINSEL = 2;                 // OA1PB select(RG6)
    AMP1CONbits.SPDSEL = 1;                 // High Power
    AMP1CONbits.CMPSEL = 0;                 // AMP select
    AMP1CONbits.AMPEN = 1;                  // AMP Enable
    /*** OP AMP#2 Setting ****/
    AMP2CONbits.AMPOE = 1;                  // Output Enable(RB3)
    AMP2CONbits.NINSEL = 3;                 // OA2NC select(RB2)
    AMP2CONbits.PINSEL = 2;                 // OA2PB select(RB1)
    AMP2CONbits.SPDSEL = 1;                 // High Power
    AMP2CONbits.CMPSEL = 0;                 // AMP select
    AMP2CONbits.AMPEN = 1;                  // AMP Enable
    /*** DMA CH0 Setting **/
    DMACONbits.DMAEN = 1;                   // DMA Enable
    DMACONbits.PRSSEL = 0;                  // Fixed Priority
    DMAH = 0x2000;                          // Upper Limit
    DMAL = 0x800;                           // Lower Limit
    DMACH0 = 0;                             // Stop Channel
    DMACH0bits.RELOAD = 1;                  // Reload DMASRC, DMADST, DMACNT
    DMACH0bits.TRMODE = 1;                  // Repeat Oneshot    
    DMACH0bits.SAMODE = 0;                  // Source Addrs No Increment
    DMACH0bits.DAMODE = 1;                  // Dist Addrs Increment
    DMACH0bits.SIZE = 0;                    // Word Mode(16bit)
    DMASRC0 = (unsigned int)&ADRES0;        // From ADC Buf0 select
    DMADST0 = (unsigned int)&Buffer;        // To Buffer select
    DMACNT0 = Max_Size;                     // DMA Counter
    DMAINT0 = 0;                            // All Clear
    DMAINT0bits.CHSEL = 0x2F;               // Select Pipeline ADC
    DMACH0bits.CHEN = 1;                    // Channel Enable
    IFS0bits.DMA0IF = 0;                    // Flag Reset
    /*** DMA CH1 Setting **/
    DMACONbits.DMAEN = 1;                   // DMA Enable
    DMACONbits.PRSSEL = 0;                  // Fixed Priority
    DMAH = 0x2000;                          // Upper Limit
    DMAL = 0x800;                           // Lower Limit
    DMACH1 = 0;                             // Stop Channel #1
    DMACH1bits.RELOAD = 1;                  // Reload DMASRC, DMADST, DMACNT
    DMACH1bits.TRMODE = 1;                  // Repeat Oneshot
    DMACH1bits.SAMODE = 1;                  // Source Addrs Increment
    DMACH1bits.DAMODE = 0;                  // Dist Addrs Not Increment
    DMACH1bits.SIZE = 0;                    // Word Mode(16bit)
    DMASRC1 = (unsigned int)&Pattern;       // From sine data
    DMADST1 = (unsigned int)&DAC1DAT;       // To D/A
    DMACNT1 = MaxRes;                       // DMA Counter MaxRes
    DMAINT1 = 0;                            // All Clear
    DMAINT1bits.CHSEL = 0x34;               // Select Timer3 trigger
    DMACH1bits.CHEN = 1;                    // Channel Enable
    IFS0bits.DMA1IF = 0;                    // Flag Reset
    /* BandGap BUF0 Setting  */
    BUFCON0 = 0;
    BUFCON0bits.BUFSTBY = 0;                // normal mode
    BUFCON0bits.BUFREF = 0;                 // 1.2V
    BUFCON0bits.BUFEN = 1;                  // BG0 Enable
    /**** DAC Setting ****/
    DAC1DAT = 0;
    DAC1CONbits.DACFM = 0;                  // Right Justfied
    DAC1CONbits.DACTRIG = 0;                // Immediate Update
    DAC1CONbits.DACTSEL = 7;                // None Trigger
    DAC1CONbits.DACREF = 3;                 // Ref = BGBUF0$B!!(B1.2V$B!_(B2=2.4V
    DAC1CONbits.DACEN = 1;                  // Enable

    /*** ADC Setting ***/
    ADCON1 = 0;                             // All Clear
    ADCON2 = 0;
    ADCON3 = 0;
    ADCON1bits.FORM = 0;                    // unsigned Integer
    ADCON1bits.PWRLVL = 1;                  // Full Power

    ADCON2bits.ADPWR = 3;                   // Always powered
    ADCON2bits.PVCFG = 0;                   // Vref+=AVDD
    ADCON2bits.NVCFG = 0;                   // Vref-=VSS
    ADCON2bits.BUFORG = 1;                  // Use Indexed Buffer
    ADCON2bits.BUFINT = 0;                  // No buffer Interrupt

    ADCON3bits.ADRC = 0;                    // Select Fsys = 16MHz
    ADCON3bits.ADCS = 1;                    // Tad = 2Tsys = 125nsec(8MHz)

    /** Sample List #0 setting**/
    ADL0CONH = 0;
    ADL0CONHbits.ASEN = 0;                  // disable auto-scan
    ADL0CONHbits.SLINT = 1;                 // Interrupt after every convert
    ADL0CONHbits.SAMC = 0;                  // aquisition time = 0.5Tad
    ADL0CONHbits.WM = 0;                    // all write
 
    ADL0CONL = 0;
    ADL0CONLbits.SLSIZE = 0;                // 1 channel in the List
    ADL0CONLbits.SLTSRC = 5;                // Timer2 Trigger
    ADL0CONLbits.SLEN = 1;                  // Enable Trigger

    ADL0PTR = 0;                            // Start from first
    /** Select Channel **/
    ADTBL0bits.ADCH = 4;                    // AN4-REF-
    
    /** Execute Calibration ADC **/
    ADCON1bits.ADON = 1;                    // ADC Enable
    while(ADSTATHbits.ADREADY == 0);
    ADCON1bits.ADCAL = 1;                   // Calibration Start
    while(ADSTATHbits.ADREADY == 0);
    ADL0CONLbits.SAMP = 1;                  // Start Sample
    ADL0CONLbits.SAMP = 0;                  // Start Conversion    
}
/***************************************************
* $B?eJ?F14|@Z$jBX$(!!%?%$%^(B2$B$N<~4|JQ99(B
*  PR2 62.5nsec$BC10L$G@_Dj(B Min 250nsec(4MHz)
***************************************************/
void Hsync(unsigned char num){
    switch(num){
        case 0:                     // 0.025usec $B"*(B 2.5usec/div
        case 1:                     // 0.05usec $B"*(B 5usec/div
        case 2:                     // 0.25usec $B"*(B 25us/div
            ADCON3bits.ADCS = 1;    // Tad = 2Tsys = 125nsec(8MHz)
            ADL0CONHbits.SAMC = 0;  // aquisition time = 0.5Tad
            PR2 = 3;                // 16MHz/4=0.25usec $B"*(B 25usec
            break;
        case 3:
            ADCON3bits.ADCS = 2;    // Tad = 4Tsys = 250nsec(4MHz)
            ADL0CONHbits.SAMC = 1;  // aquisition time = Tad
            PR2 = 15;               // 1usec $B"*(B 100us/div
            break;
        case 4:
            ADCON3bits.ADCS = 4;    // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 2;  // aquisition time = 2Tad
            PR2 = 79;               // 5usec $B"*(B 500usec/div
            break;
        case 5:
            ADCON3bits.ADCS = 4;    // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 4;  // aquisition time = 5Tad
            PR2 = 159;              // 10usec $B"*(B 1msec/div
            break;
        case 6:
            ADCON3bits.ADCS = 4;    // Tad = 8Tsys = 500nsec(2MHz)
            ADL0CONHbits.SAMC = 7;  // aquisition time = 8Tad
            PR2 = 1599;             // 100usec  10msec/div
            break;
        default:                    // $B$I$l$G$b$J$$>l9gJQ99$J$7(B
            break;
    }
}
/***************************************
*  UART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void){
    char  data;

    /* $B<u?.%(%i!<%A%'%C%/(B */
    IFS0bits.U1RXIF = 0;                    // $B3d$j9~$_%U%i%0%/%j%"(B
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                    // $B%(%i!<%U%i%0%/%j%"(B
        U1MODE = 0;                         // UART1$BDd;_(B
        U1MODE = 0x8808;                    // UART1$BM-8z2=(B
        Index = 0;
    }
    else {                                  // $B@5>o<u?.$N>l9g(B
        if(Index < 64){                      // 8$B%P%$%H0J2<$N>l9g(B
            RcvBuf[Index++] = U1RXREG;      // $B%G!<%?<h$j=P$7(B
            if(Index >= 64){                 // 8$B%P%$%H=*N;$+(B
                Flag = 1;                   // $B<u?.40N;%U%i%0%*%s(B
                Index = 0;                  // $B%]%$%s%?%j%;%C%H(B
            }
        }
        else                                // $B%P%C%U%!%*!<%P!<$N>l9g(B
            data = U1RXREG;                 // $BFI$_Ht$P$7$FL5;k(B
    }
}
 /********************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);              // $BAw?.%l%G%#!<BT$A(B
    U1TXREG = Data;                      // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendData(unsigned int * buf)
{
    int i;
    Send(0x4D);                                     // $B%X%C%@Aw?.(B
    Send(0x4E);
    for(i= 1; i<2050; i++){                         // 4100$B%P%$%H0l3gAw?.(B
        Send((unsigned char)((*buf/4) % 128));      // $B>e0L%P%$%HAw?.(B
        Send((unsigned char)((*buf/4) / 128));      // $B2<0L%P%$%HAw?.(B
        buf++;
    }
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(unsigned char *cmd)
{
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    Delayms(1000);                      // $BJV?.%9%-%C%WMQCY1d(B
}

/***********************************************
* $B%?%$%^(B4$B$K$h$k(B1msec$BC10L$NCY1d4X?t(B Tcy=16MHz
***********************************************/
void Delayms( unsigned int t){
    IFS1bits.T4IF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PR4 = 2000;                         // 1msec$B@_Dj(B
    T4CON = 0x8010;                     // $B%?%$%^(B4$B%9%?!<%H!!%W%j%9%1!<%i(B 1/8
    while (t--) {                       // $B7+$jJV$72s?t(B
        while (!IFS1bits.T4IF);         // 1msec$BBT$A(B
        IFS1bits.T4IF = 0;              // $B3d$j9~$_%U%i%0%/%j%"(B
    }
}


